// bwin.h 2017-02-05 
#include <windows.h>
#include <string>
#include <vector> 

using namespace std;
#include "bwin.h"			// GetFileNames

//-----------------------------------------------------------------------------
std::wstring StringToWString(const std::string& s)
{
	std::wstring temp(s.length(), L' ');
	std::copy(s.begin(), s.end(), temp.begin());
	return temp;
}

std::string WStringToString(const std::wstring& s)
{
	std::string temp(s.length(), ' ');
	std::copy(s.begin(), s.end(), temp.begin());
	return temp;
}
//-----------------------------------------------------------------------------
void GetFileNames(const std::string& path, const std::string& mask, std::vector<std::string>& file_names) //   file_names      path . 
{
	HANDLE hFind;
	WIN32_FIND_DATA find_data;
	int plen = (int)path.length();
	std::string path2 = path;
	if (plen > 0) {
		char ch = path[plen - 1];
		if (ch != '\\' && ch != '/')
			path2 = path + "/";
	}
	std::string fmask = path2 + mask;

#ifdef _UNICODE
	std::wstring wmask = StringToWString(fmask);
	hFind = FindFirstFile(wmask.c_str(), &find_data);
	if (hFind != INVALID_HANDLE_VALUE) {
		do {
			if (!(find_data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				file_names.push_back(WStringToString(find_data.cFileName));
			}
		} while (FindNextFile(hFind, &find_data));
	}
#else
	hFind = FindFirstFile(fmask.c_str(), &find_data);
	if (hFind != INVALID_HANDLE_VALUE) {
		do {
			if (!(find_data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				file_names.push_back(find_data.cFileName);
			}
		} while (FindNextFile(hFind, &find_data));
	}
#endif





}

//