// orders.h: 2012-04-26 order(a,p)
// (c) Khashin S.I.  khash2@gmail.com

//  ,   ,     
//     a     p,   2  
//   .

//============================================================================
// CLASS orders
//============================================================================
class orders {
private:
	static unsigned a;						// base
	static unsigned nord;					// number of primes
	static unsigned *ord;					// array of order(a,p[i]), size = nord
	static u64      maxP_;					// last P
	//
	static int load(char *fname, u64 N=0);		// load orders (base)
	static int save(char *fname);				// save orders
	static char *order_file_name( unsigned a0);
	static int	calc(unsigned a0, u64 maxN);	// calculate orders(base)
public:
	static int  fill(unsigned a0, u64 maxN=0);	// load/calculate seive and orders(base)
	static unsigned nOrd() {return nord; };		// number of calculated orders
	static u64      maxP() {return maxP_; };	// last P
	static unsigned A()	   {return a; };		// base
	static u64      ordI(unsigned i);			// order(a, p(i))
	static u64      ordP(u64 p0);				// order(a, p0)
	static u64      ordPP(u64 p0, int k);		// order(a, p0^k)
	static u64      ordN(u64 n);				// order(a, n), n - any natural
	static u64      iordP(u64 p0);				// (p0-1)/order(a, p0)
	static unsigned iordI(unsigned ip0);		// coorder(p[ip0])
};
