// t_util.cpp : 1409   (  cp-1251)
//

#pragma warning(disable : 4996)
#include <string.h>

#include "porter.h"		//  

//============================================================================
/* 

  

    :

    , , , , , , , , .      .
 RV      .    ,     .
 R1       -.
 R2   R1    -.



   :

 RV = .
 R1 = .
 R2 = .

      .     
     .

PERFECTIVE GERUND

  1: , , .
  2: , , , , , . 

    1      .

ADJECTIVE

 , , , , , , , , , , , , , , , , , , , , , , , , , .

PARTICIPLE

  1: , , , , .
  2: , , .

    1      .

REFLEXIVE

 , .

VERB

  1: , , , , , , , , , , , , , , , , .
  2: , , , , , , , , , , , , , , , 
           , , , , , , , , , , , , , .

    1      .

NOUN

 , , , , , , , , , , , , , , , , , , , 
 , , , , , , , , , , , , , , , , .

SUPERLATIVE:

 , .

DERIVATIONAL

 , .

ADJECTIVAL

 ADJECTIVAL   ADJECTIVE  PARTICIPLE + ADJECTIVE. :  =  +  + .



         . , 
      ,   .

      RV. ,    PERFECTIVE GERUND 
          RV. 
   RV     .

 1

   PERFECTIVE GERUND.          .

 ,   REFLEXIVE (  ). 
       : ADJECTIVAL, VERB, NOUN. 
         .

 2

        .

 3

   R2   DERIVATIONAL   .

 4

     :

         .
     SUPERLATIVE    
        ,     .
        .

*/
//----------------------------------------------------------------------------
static char *cmp_last(char *s, char *r) //   s    r,     , NULL 
{
	int ls = (int)strlen(s);
	int lr = (int)strlen(r);
	if( ls<lr ) return NULL;	//  s  r
	s += ls-lr;					// s        
	char *s0 = s;
	while( *s ) if( *s++ != *r++ ) return NULL;
	return s0;
}
//----------------------------------------------------------------------------
static char *cmp_prev(char *s, char *r) // ,     s  r.  s-len(r)  NULL
{
	int lr = (int)strlen(r);
	s -= lr;					// s        
	char *s0 = s;
	while( *r ) if( *s++ != *r++ ) return NULL;
	return s0;
}
//----------------------------------------------------------------------------
// r -   -  , r[0], .., r[n-1], r[n]=NULL
static char *cmp_last_list(char *s, char *r[]) //         s,  NULL
{
	char *s1;
	for( int i=0; *r != NULL; r++, i++ )
	{
		s1 = cmp_last(s, *r);
		if( s1 != NULL ) return s1;
	}
	return NULL;
}
//----------------------------------------------------------------------------
// r -   -  , r[0], .., r[n-1], r[n]=NULL
static char *cmp_prev_list(char *s, char *r[]) // ,     s  r[i]
{
	char *s1;
	for( int i=0; *r != NULL; r++, i++ )
	{
		s1 = cmp_prev(s, *r);
		if( s1 != NULL ) return s1;
	}
	return NULL;
}
//----------------------------------------------------------------------------
static char glas   [] = "";

//----------------------------------------------------------------------------
static char * find_g_s(char *w) //   w    -,  NULL,   
{
	char *s = w;
	while(*s){
		s = strpbrk(s, glas );			//     
		if( s==NULL ) return NULL;		//  
		s++;							//      
		if( strchr(glas, *s) == NULL ) return s+1;	//    . .
	}
	return NULL;
}
//----------------------------------------------------------------------------
static char * find_perf(char *w) //   PERFECTIVE GERUND  w
{
	char *p_g1  [] = { "", "", "", NULL };
	char *p_g1a [] = { "", "", "", "", "", "", NULL  };
	char *p_g2  [] = { "", "", "", "", "", "", NULL  };
	char *s;
	s = cmp_last_list(w, p_g1a);
	if( s != NULL) return s+1;
	return cmp_last_list(w, p_g2);
}
//----------------------------------------------------------------------------
static char * find_verb(char *w) //   VERB  w
{
	char *verb1 [] = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", NULL };
	char *verb1a[] = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", 
		               "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", NULL };
	char *verb2 [] = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", 
		               "", "", "", "", "", "", "", "", "", "", "", "", NULL };
	char *s;
	s = cmp_last_list(w, verb1a);
	if( s != NULL) return s+1;
	return cmp_last_list(w, verb2);
}
//----------------------------------------------------------------------------
static char * find_adj(char *w) //   ADJECTIVAL  w
{
	char *adj   [] = { "", "", "", "", "", "", "", "", "", "", "", "", "", 
		              "", "", "", "", "", "", "", "", "", "", "", "", "", NULL  };
	char *part1 [] = { "", "", "", "", "", NULL };
	char *part1a[] = { "", "", "", "", "", "", "", "", "", "", NULL };
	char *part2 [] = { "", "", "", NULL };

	char *s, *s1;
	s = cmp_last_list(w, adj);
	if( s == NULL) return NULL;
	if( s-w<3 ) return s;
/* PARTICIPLE  1: , , , , .
               2: , , .
      1      .
   ADJECTIVAL   ADJECTIVE  PARTICIPLE + ADJECTIVE. :  =  +  + .
*/
	s1 = cmp_prev_list( s, part1a);
	if( s1 != NULL ) return s1+1;
	s1 = cmp_prev_list( s, part2);
	if( s1 != NULL ) return s1;
	return s;
}
//----------------------------------------------------------------------------
//    " " ( )
// ,   s       ( )   cp-1251.
void StemmPorter(char *s0)
{
	//   ,   s0      
	char *letters = "";	//    33- 
	char *s;

	for (s = s0; *s; s++) {
		if (strchr(letters, *s) == NULL) {	//    -  ,
			*s = 0;							//  ,    
			break;
		}
		if (*s == '') *s = '';			//  ''  ''  
	}

	char *refl  [] = { "", "", NULL };
	char *deriv [] = { "", "", NULL };
	char *noun  [] = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		               "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", NULL };
	char *supl  [] = { "", "", NULL };

/*
 .   :

 RV = .
 R1 = .
 R2 = .

*/

	if (strlen(s0) < 2) {					//    ,
		return;								//     
	}
	char *RV = strpbrk(s0, glas );			//     
	if( RV==NULL ) return;					//  
	RV++;									//      
	if( *RV == 0 ) return;					//  RV ,   
	char *R1 = find_g_s(s0);
	if( R1==NULL ) return;
	char *R2 = find_g_s(R1);
	int l;
/*
  1 ----------------------------------------------------------

   PERFECTIVE GERUND.          .

 ,   REFLEXIVE (  ). 
       : ADJECTIVAL, VERB, NOUN. 
         .

*/
	s = find_perf(R1);
	if( s != NULL) *s=0;
	else {
		s = cmp_last_list(R1, refl);
		if( s != NULL) *s=0;
		else{
			s = find_adj(R1);
			if( s != NULL) *s=0;
			else{
				s = find_verb(R1);
				if( s != NULL) *s=0;
				else{
					s = cmp_last_list(R1, noun);
					if( s != NULL) *s=0;
				}
			}
		}
	}
	//  2.        .
	l = (int)strlen(R1);
	if( R1[l-1]=='' ) R1[l-1]=0;

	//  3.   R2   DERIVATIONAL   .
	s = R2==NULL? NULL : cmp_last_list(R2, deriv);
	if( s != NULL) *s=0;

/*
  4.     :

         .
     SUPERLATIVE    
        ,     .
        .
*/
	l = (int)strlen(R1);

	if( R1[l-1]=='' &&  R1[l-2]==''  ) R1[l-1]=0;	//         .
	else{
		s = cmp_last_list(R1, supl);					//      SUPERLATIVE    
		if( s != NULL)
		{
			*s=0;
			if( s[-1]=='' && s[-2]=='' ) s[-1]=0;		//     ,     .
		} else 
		{
			if( R1[l-1]=='' ) R1[l-1]=0;				//         .
		}
	}
}// StemmPorter(char *s0)
//-----------------------------------------------------------------------------
