// segment.h: -   
// (c) Khashin S.I.  khash2@gmail.com
//
//////////////////////////////////////////////////////////////////////
#ifndef IMATRIX
#error iMatrix.h not included
#endif

#ifndef IMATRIX3
#error iMatrix3.h not included
#endif

#define SEGMENT


/*
	      ,   -
	  .

	   .   k   
	,       k.

	   .    
	  (,    -   
	).        
	.

	 segm -   matr    (  , ).
	  .

	2010-04-02:     :
	,  

*/

//  
//void neighbor (int x, int y, int k, int &x1, int &y1);	//    k=0|1|2|3
//void neighbor8(int x, int y, int k, int &x1, int &y1);	//    k=0..7
void listVicinity( pvector &list, int x0, int y0, int mx, int my); // list -     (x0,y0);

class segm: public matr {
private:
	int max;					//   
public:
	int aSz;					//   (  nSgm,   )
	int *area;					//  
	double *midX, *midY, *offs;	//    ..  
	double *midR, *midG, *midB;	//    
	matr top;					// , top[i,j] -      (i,j)
	matr ctop;					// ctop[i,j] -         (i,j)

/*


	//matr neib;					//      
	matr brd;					//  .   (x,y)  4 :
								// 0 -    ,     (x,y)
								// 1 -   ,  - 
								// 2 -   ,  - 
								// 3 -    ,  
*/
public:
    // construtor/destructor
	segm(int mx_=0, int my_=0);
	~segm();

	int Max();					//   	

	void drawSegments(char *bmpname);				//     bmpname  
	void drawSegments(matr &rgb, char *bmpname);	//      rgb   bmpname
	void drawSegments(matr3 &a, char *bmpname);	//      rgb   bmpname
	void drawSegments(matr &r, matr &g, matr &b, char *bmpname);	//      rgb   bmpname

	//    
	int		minInSegm(int k, matr &a, int &x, int &y);// .   a   #k
	int		maxInSegm(int k, matr &a, int &x, int &y);// .  a   #k
	int		sumInSegm(int k, matr &a);				//    a   #k
	double	midInSegm(int k, matr &a);				//    a   #k
	void	setInSegm(int k, matr &a, int v);		//   #k     a  v

	//  
	void	minimizeIndexes();						//    
	void	sortBySize();							//     
	void	sortBySize(int i1, int i2);				//  i1..i2     
	void	join(int i, int j);						//   i  j   

	//  
	void	getList( pvector &list, int v );		// list :=  ,   a[x,y]==v
	void	addList( pvector &list, int v );		// list +=  ,   a[x,y]==v
	void	setByList(pvector &list, int v );		//      a[x,y]=v
	void	areas( int v0, int v1, int *sz );		// sz[i] :=   v0+i

	// 
	int		neighborCount (int x, int y, int v=-1 );//   (8)      v
	int		neighborCount2(int x, int y, int v=-1 );//   (8)        v
	// 
	bool	isBorder4( int x, int y );				//        4- 
	bool	isBorder8( int x, int y );				//        8- 
	int		box( int iSegm, int &x0, int &y0, int &x1, int &y1); // (x0,y0)-(x1,y1) - ,  
	//      iSegm?
	bool	isInBorder4( int x, int y, int iSegm );	//     iSegm,     4-  -  
	bool	isInBorder8( int x, int y, int iSegm );	//     iSegm,     8-  -  
	//      iSegm?
	bool	isOutBorder4( int x, int y, int iSegm );//      iSegm,     4-  - 
	bool	isOutBorder8( int x, int y, int iSegm );//      iSegm,     8-  - 

	int		nearestB(int x0, int y0, int &x1, int &y1);	//   (x,y)  (x1,y1) -    

	void	dSegm(pvector &list,  histogr &h);		// h :=      list
	void	dSegm(int x0, int y0, histogr &h);		// h :=      (x0,y0)



	//   :
	void	inBorder(int iSegm, pvector &list);		// list :=      iSegm
	void	outBorder(int iSegm, pvector &list);	// list :=      iSegm
	
	//     (x0,y0)  v2.  .
	int		connectRegion( int x0, int y0, int v2, int type=8, pvector *list=NULL);

	bool	isConnected(int iSegm, int type=8);		//  ? iSegm<0 -    
	void	connectSegmentation(int type=8);		//        
	void	connectSegmentationP(int type=8);		//         (  )

	// / 
	int		expandSegment(int iSegm);				//   iSegm     1 
	int		expandSegment(int iSegm, int iSegm0);	//   iSegm     1       iSegm0
	int		expandSegments(int iSeg1, int iSeg2, int iSegm0);	//   iSeg1..iSeg2     1       iSegm0

	int		decreaseSegment(int iSegm, int v);		//     iSegm    v
	int		decreaseSegments(int iSegm1, int iSegm2, int v);//    iSegm1..iSegm2    v
	void	kill_small_segments(int minSegSize);	//   

private:
	//    cellAutom
	int		cellAutom1(int k, pvector *list = NULL);//       k. 
	int		cellAutom2(int k, pvector &list, pvector &list2);	//       k   . 
public:
	int		cellAutom(int k);						//     k

	//   .
	void	sRelease();								//  .
	void	getInfo(matr *a = NULL, matr3 *a3 = NULL);	//    
	void	getInfo(matr &a) { this->getInfo(&a); };//        
	void	getInfo(matr3 &a) { this->getInfo(NULL, &a); };//        
	//  :
	// getInfo();          -    
	// getInfo(matr a);    -   
	// getInfo(matr3 rgb); -   

	//   ., 
	int		Area(int iSegm);
	double	MidX(int iSegm);
	double	MidY(int iSegm);
	double	Offs(int iSegm);

	double	MidR(int iSegm);
	double	MidG(int iSegm);
	double	MidB(int iSegm);

	double	colDist(int iSegm1, int iSegm2);		//    
	double	colBDist(int iSegm1, int iSegm2);		//      
	int		bordSize(int iSegm1, int iSegm2);		//     

	void	saveInfo(char *fname);					//       fname

/*






	int		cellAutomW(int k);						//     k    3-2 !!!!!! -------------

	void	TopReduce( int kSegm );					//      ctop[i,j],       kSegm
	//  
public:

	// split:    
private:
	//    split:
	void	specSort( int i1, int i2, int minSegSize);	//     split
public:
	int		splitRad( int i, int rad, int minSegSize);	//   i      rad.   
	int		split( int i, int dStep, int type, int minSegSize);//   i   (dStep  ).   

	//     ----------------------------------------------
	bool bord(int x, int y, int k);					//      (x,y)   k (k=0|1|2|3)
	bool bord(int x1, int y1, int x2, int y2);		//      (x1,y1)  (x2,y2)
	void bord_init();								//  
	void bord_set(int x, int y, int k);				//    (k=0)   (k=1)   (x,y)
*/

};



//void	expandList( pvector &list, int mx, int my );//   list    
//void	deleteBorderFromList( segm &sgm, pvector &list, int v, int type ); //  4(8)-      v
//void matrixNormalizationQ( matr  &a, int k, double p0, double p1 );	//       [0..k]       p0, p1

//  
//void	drawSegments_( segm &sgm, char *bmpname, int s0, int s1 );	//   s0..s1     





//
