// vTransf.h: ,    
// (c) Khashin S.I.  khash2@gmail.com
//
#ifdef VTRANSF
#error Secondary include
#endif
#define VTRANSF

//  ,   .
//    -   
//void    vError(const char *format, ...);		// show error function

enum tTransf 
{	
	tTransf_none,		//  
	tTransf_shift,		//  
	tTransf_rotate,		//  +  
	tTransf_affine,		//   
	tTransf_project		//   ,   
};
/*
	tTransf_shift,		//  
	x0 = x + a[0];
	y0 = y + a[1];

	tTransf_rotate,		//  +  
	x0 = a[0] + cos(a[2])*x + sin(a[2])*y;
	y0 = a[1] - sin(a[2])*x + cos(a[2])*y;

	tTransf_affine,		//   
	x0 = a[0] + a[1]*x + a[2]*y;
	y0 = a[3] + a[4]*x + a[5]*y;

*/

#define CvTransfSize 6	//     
						//    ,    : 8

class CvTransf {
private:
	tTransf kind;	//   
	double a[CvTransfSize];	//   .  -   
							//  
public:
	CvTransf();		// ,   
	CvTransf(double dx, double dy);					// ,  
	CvTransf(double dx, double dy, double angle);	// ,  
	CvTransf(double a0, double a1, double a2, double a3, double a4, double a5);	// ,  
	~CvTransf();	// 

	void set(double dx, double dy);					//  
	void set(double dx, double dy, double angle);	//  
	void set(double a0, double a1, double a2, double a3, double a4, double a5);	//  
	double get(int i);								//   i
	void inc(int i, double v);						//    i

	void setRot(double x0, double y0, double angle);//     (x0,y0)
	void setSRot(double x0, double y0, double x1, double y1, double x2, double y2, double x3, double y3);//  + ,  P0->P2, P1->P3
	void setAff(double x0, double y0, double a1, double a2, double a4, double a5);//     (x0,y0)
	void addShift(double vx, double vy);			//  

	//   ,  
	//	A(x1, y1) = (x1s, y1s), 
	//	A(x2, y2) = (x2s, y2s), 
	//	A(x3, y3) = (x3s, y3s), 
	void setAffine(double x1,  double y1,   double x2,  double y2,   double x3,  double y3,  //   ,  
				   double x1s, double y1s,  double x2s, double y2s,  double x3s, double y3s);
	
	int  Kind() { return kind; }
	int  N();	//  
	void setArr(double *b, int n_);	// this->a[0..n-1] := b[0..n-1]
	void addArr(double *b, int n_, double v);	// this->a[0..n-1] += v*b[0..n-1]
	void set1();	//   .
	void copyFrom( CvTransf &b);
	void convertFrom( CvTransf &b, tTransf knd=tTransf_none);	// this= b   knd.  knd  ,    this->kind;
	void apply( double x, double y,  double &x0, double &y0 );	// (x0,y0) :=     (x,y) 
	void save( const char *fname );								// append CvTransf to file
	void save( FILE *f );										//  CvTransf   
	//     (x,y)  transfX, transfY   #k
	double diffX( double x, double y, int k );
	double diffY( double x, double y, int k );

	void mult( double k );	//    k 
	void mult( CvTransf &a, CvTransf &b);	// this = a*b.  ,  . a*b(P) = a(b(P))
	//void multLeft( CvTransf &b);// this = b*this.  ,  
	void divide( CvTransf &a, CvTransf &b);	//  this ,  this*a = b
	void revers( CvTransf &b);				// this = (b)
	void power( CvTransf &b, int k);		// this = b^k;

	void setNothing();	//   
	bool isNothing();	// ,     

	double *data() { return a; };
	void code6(double cx, double cy, double r, double *buff);	//    6  
	void code6(int cx, int cy, int r, int *buff);				//    6  
	void decode6(int cx, int cy, int r, int *buff);				//    6  
	void decode6(double cx, double cy, double r, double *buff);	//    6 
	//void decode7(double cx, double cy, double r, double *buff);	//    6   ( )
	//void decode8(double cx, double cy, double r, double *buff);	//    6  
	char *code6Str( int cx, int cy, int r, bool xls=false);		// :    6  
	char *code6Sts( int cx, int cy, int r, bool xls=false);		// code6Str    16
	char *codeSimpl(bool xls=false);							//  
	//  
	void lowKind();												//   ,  
	void Transf2shift(CvTransf  &sh, double px, double py);		//      (px,py)
	void Transf2rot(CvTransf &rot, double px, double py, double r);//        (px,py)   r
	double TransfDist(CvTransf &a2, double px, double py, double r);// .     (px,py)   r  this(v)  a2(v)
	double TransfMaxOffs(double px, double py, double r);		//        (px,py)   r



};

//   ,  
//	A(x1, y1) = (x1s, y1s), 
//	A(x2, y2) = (x2s, y2s), 
//	A(x3, y3) = (x3s, y3s), 
void affineTMove(double x1,  double y1,   double x2,  double y2,   double x3,  double y3,  
				 double x1s, double y1s,  double x2s, double y2s,  double x3s, double y3s,  
				 double &a0, double &a1,  double &a2, double &a3,  double &a4, double &a5);	//   ,  

bool   TransBad  (  CvTransf &a, double v );					//  ?

void Transt_FullTest();		//    CvTransf;